/* This Program Calculates Percentage of Trans and Gauche States     */
/* Created by: Dr. Jeff Klauda                                       */
/* Date: 03/23/2004                                                  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE *main_inp;
FILE *main_out;

#define MAX_R 100000
#define NUM 2

double block_ave(double av_run, int ntot, int nblocks, double prop[]);

int main(void)
{
    char input[9]="area.dat",output[80];
    int i,j,ntot,status,count=0,nblock,nl;
    double blk_sz,t_start,delta_t,blk,avg=0,sd,sdD,avgD=0;
    double *area=new double[MAX_R];
    double dummy;
   

    main_inp = fopen (input,"r");

    printf("\n\nOutput File: ");
    scanf("%s",&output);
    main_out = fopen (output,"w");

    printf("\n\nBlock Size in steps: ");
    scanf("%lf", &blk_sz);



// Read in data

    i=-1;
    status = 1;
    while(status != EOF)
    {
        i++;
     
           status=fscanf(main_inp,"%lf%lf",&dummy,&area[i]);

        avgD = avgD + area[i];
    }
    fclose(main_inp);
    ntot=i;
    avgD=avgD/ntot;

//  Block Averaging

   
    
    fprintf(main_out,"block#\tSurf. Area Ang^2\n");
    nblock = int(ntot/(blk_sz));
    sdD= block_ave(avgD,ntot,nblock,area);
    fprintf(main_out,"\n\nAverage= %1.5lf+-%1.5lf",avgD,sdD);

}
double block_ave(double av_run, int ntot, int nblocks, double prop[])
{
   double av, sum=0, sum_av=0;
   int i,j;

   for(i=0;i<nblocks;i++)
   {
        for(j=i*ntot/nblocks;j<(i+1)*ntot/nblocks;j++)
            sum_av=prop[j]+sum_av;
        av=sum_av/(1.0*ntot/nblocks);
        fprintf(main_out,"%d\t%1.5lf\n",i,av);
        sum=sum+(av-av_run)*(av-av_run);
        sum_av=0;
   }

   sum=sqrt(1.0/nblocks*sum);
   printf("\n");                                   // Xiao: Add to restart the line after run
   return sum;
}

